;													
; 300ms Echo ATmega1284P							
; Bernhard.Erfurt@gmx.de							
; https://www.mikrocontroller.net/topic/474376#new	
; 05.2019											
;													

;												
; LED blinken:									
; ROT: 				Interrupt Error				
; ROT+GELB:			Watchdog Error				
; ROT+GELB+GRN:	Programm-Check Error		
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT							=22000000	; 22 MHz			
; REGISTER										
.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

; LED-GRN										
.equ LED_GRUEN_PIN_NR		= 0
.equ LED_GRUEN_DDR			= DDRB
.equ LED_GRUEN_PORT			= PORTB
; LED-GELB										
.equ LED_GELB_PIN_NR		= 1
.equ LED_GELB_DDR			= DDRB
.equ LED_GELB_PORT			= PORTB
; LED-ROT										
.equ LED_ROT_PIN_NR			= 2
.equ LED_ROT_DDR			= DDRB
.equ LED_ROT_PORT			= PORTB


; TASTE "A"										
.equ TASTE_A_PIN_NR			= 2
.equ TASTE_A_PIN			= PINC
.equ TASTE_A_DDR			= DDRC
.equ TASTE_A_PORT			= PORTC
; TASTE "B"										
.equ TASTE_B_PIN_NR			= 3
.equ TASTE_B_PIN			= PINC
.equ TASTE_B_DDR			= DDRC
.equ TASTE_B_PORT			= PORTC
; TASTE "C"										
.equ TASTE_C_PIN_NR			= 4
.equ TASTE_C_PIN			= PINC
.equ TASTE_C_DDR			= DDRC
.equ TASTE_C_PORT			= PORTC
; TASTE "D"										
.equ TASTE_D_PIN_NR			= 5
.equ TASTE_D_PIN			= PINC
.equ TASTE_D_DDR			= DDRC
.equ TASTE_D_PORT			= PORTC
; TASTE "E"										
.equ TASTE_E_PIN_NR			= 6
.equ TASTE_E_PIN			= PINC
.equ TASTE_E_DDR			= DDRC
.equ TASTE_E_PORT			= PORTC
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)					
.equ adr_DATEN						=SRAM_START+0		; 0x0100 START Adresse 		

.equ adr_ZEIGER_L					=SRAM_START+2
.equ adr_ZEIGER_H					=SRAM_START+3
.equ adr_BUFFER						=SRAM_START+10

.equ adr_SRAM_CHECK					=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	



.cseg							;Beginn eines Code-Segmentes
.org 0							;Startadresse=0				
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 rjmp WDT 			 ; Watchdog Timeout			
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF 	; Timer1 Overflow		
.org 0x0020 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp TIM3_OVF 		 ; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	call wait_100ms
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	sbi (LED_GELB_PORT)  ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)				; STACK initialisieren	
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call SRAM_CLEAR						; SRAM_CLEAR			
	call PORT_CLEAR						; Ports auf EINGANG		
	call STARTWERTE						; Startwerte			
	call WDR_INITIALISIERUNG			; WDR					
	call LED_INITIALISIERUNG			; LED_INITIALISIERUNG	
	call TIMER0_INITIALISIERUNG_PWM8	; PWM					
	call TIMER1_INITIALISIERUNG_PWM16	; PWM					
	call TIMER2_INITIALISIERUNG_PWM8	; PWM					
	call TIMER3_INITIALISIERUNG_PWM16	; PWM					
	call ADC_INITIALISIERUNG			; ADC					
	call TASTATUR_INITIALISIERUNG		; Tasten				
	call PROGRAMM_CHECK					; Check					
	sei									; Interrupts enable		
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	rjmp ADC_MESSUNG
;	rjmp SAEGEZAHN
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; PWM			
.include "ADC.asm"				; ADC			
.include "SOUND.asm"			; Sound			
.include "TASTEN.asm"			; Tasten		
.include "SONSTIGES.asm"		; sonstiges		
.include "WAIT.asm"				; wait			



